## git-annex 6.20160418

=== debian/changelog ===
git-annex (6.20160418-1) unstable; urgency=medium

  * Package 6.20160418-1

 -- Richard Hartmann <richih@debian.org>  Thu, 21 Apr 2016 06:12:10 +0200

git-annex (6.20160418) unstable; urgency=medium

  * smudge: Print a warning when annex.thin is set, as git's smudge
    interface does not allow honoring that configuration.
  * webapp: When $HOME is a git repository, and has been initialized for
    use by git-annex, opening the webapp went ahead and ran the assistant
    there, annexing all files. Since this is almost certianly not
    desirable, especially when the user is just opening the webapp from
    a dekstop menu which happens to run it in $HOME, the webapp will now not
    treat such a $HOME git repository as a git-annex repository.
  * webapp: Update url to add gitlab.com ssh key.
  * Fix bug in v6 mode that prevented treating unlocked executable files
    as annexed. If you have such files, run git annex init --version=6
    to update the cache after upgrading to this version of git-annex.
  * Preserve execute bits of unlocked files in v6 mode.
  * fsck: Warn when core.sharedRepository is set and an annex object file's
    write bit is not set and cannot be set due to the file being owned
    by a different user.
  * Fix hang when dropping content needs to lock the content on a
    ssh remote, which occurred when the remote has git-annex version
    5.20151019 or newer. (The bug was in the client side; the remote
    git-annex-shell does not need to be upgraded.)

 -- Joey Hess <id@joeyh.name>  Mon, 18 Apr 2016 18:33:52 -0400

git-annex (6.20160412-1) unstable; urgency=medium

  * Package 6.20160412-1

 -- Richard Hartmann <richih@debian.org>  Fri, 15 Apr 2016 01:14:02 +0200

git-annex (6.20160412) unstable; urgency=medium

  * adjust --unlock: Enters an adjusted branch in which all annexed files
    are unlocked. The v6 equivilant of direct mode, but much cleaner!
  * Upgrading a direct mode repository to v6 has changed to enter
    an adjusted unlocked branch. This makes the direct mode to v6 upgrade
    able to be performed in one clone of a repository without affecting
    other clones, which can continue using v5 and direct mode.
  * init --version=6: Automatically enter the adjusted unlocked branch
    when filesystem doesn't support symlinks.
  * ddar remote: fix ssh calls
    Thanks, Robie Basak
  * log: Display time with time zone.
  * log --raw-date: Use to display seconds from unix epoch.
  * v6: Close pointer file handles more quickly, to avoid problems on Windows.
  * sync: Show output of git commit.
  * annex.thin and annex.hardlink are now supported on Windows.
  * unannex --fast now makes hard links on Windows.
  * Fix bug in annex.largefiles mimetype= matching when git-annex
    is run in a subdirectory of the repository.
  * Fix build with ghc v7.11. Thanks, Gabor Greif.

 -- Joey Hess <id@joeyh.name>  Tue, 12 Apr 2016 14:53:22 -0400

git-annex (6.20160318) unstable; urgency=medium

  * metadata: Added -r to remove all current values of a field.
  * Fix data loss that can occur when annex.pidlock is set in a repository.
  * Fix bug preventing moving files to/from a repository with annex.pidlock set.
  * Fix shared lock file FD leak.
  * Fix metadata hook behavior when multiple files are added at once.
    Thanks, Klaus Ethgen.
  * Added dependencies on haskell mountpoints and disk-free-space
    libraries, removing FFI code from git-annex.
  * dropkey: Add --batch and --json.
  * Fix OSX dmg to include libraries needed by bundled gpg,
    lost in last release.
  * Always try to thaw content, even when annex.crippledfilesystem is set.
  * Correct git-annex info to include unlocked files in v6 repository.
  * Sped up git-annex add in direct mode and v6 by using
    git hash-object --stdin-paths.
  * Sped up git-annex merge by using git hash-object --stdin-paths.

 -- Joey Hess <id@joeyh.name>  Fri, 18 Mar 2016 11:30:36 -0400

git-annex (6.20160229-1) unstable; urgency=medium

  * Package 6.20160229-1

 -- Richard Hartmann <richih@debian.org>  Tue, 08 Mar 2016 00:12:28 +0100

git-annex (6.20160229) unstable; urgency=medium

  * Update perlmagick build dependency. Closes: #789225
  * Fix memory leak in last release, which affected commands like
    git-annex status when a large non-annexed file is present in the work
    tree.
  * fsck: When the only copy of a file is in a dead repository, mention
    the repository.
  * info: Mention when run in a dead repository.
  * Linux and OSX standalone builds put the bundled gpg last in PATH,
    so any system gpg will be preferred over it.
  * Avoid crashing when built with MagicMime support, but when the magic
    database cannot be loaded.
  * Include magic database in the linux and OSX standalone builds.
  * Fix memory leak when hashing files, which triggered during fsck
    when an external hash program was not used.
    (This leak was introduced in version 6.20160114.)
  * Support --metadata field<number, --metadata field>number etc
    to match ranges of numeric values.
  * Similarly, support preferred content expressions like
    metadata=field<number and metadata=field>number
  * The pre-commit-annex hook script that automatically extracts
    metadata has been updated to also use exiftool.
    Thanks, Klaus Ethgen.

 -- Joey Hess <id@joeyh.name>  Mon, 29 Feb 2016 12:41:49 -0400

git-annex (6.20160217) unstable; urgency=medium

  * Support getting files from read-only repositories.
  * checkpresentkey: Allow to be run without an explicit remote.
  * checkpresentkey: Added --batch.
  * Work around problem with concurrent-output when in a non-unicode locale
    by avoiding use of it in such a locale. Instead -J will behave as if
    it was built without concurrent-output support in this situation.
  * Fix storing of filenames of v6 unlocked files when the filename is not
    representable in the current locale.
  * fsck: Detect and fix missing associated file mappings in v6 repositories.


=== debian/control ===
Source: git-annex
Section: utils
Priority: optional
Build-Depends: 
	debhelper (>= 9),
	ghc (>= 7.4),
	cabal-install,
	libghc-mtl-dev (>= 2.1.1),
	libghc-missingh-dev,
	libghc-data-default-dev,
	libghc-hslogger-dev,
	libghc-pcre-light-dev,
	libghc-cryptonite-dev | libghc-cryptohash-dev (>= 0.11.0),
	libghc-sandi-dev,
	libghc-utf8-string-dev,
	libghc-aws-dev (>= 0.9.2-2~),
	libghc-conduit-dev,
	libghc-resourcet-dev,
	libghc-quickcheck2-dev,
	libghc-monad-control-dev (>= 0.3),
	libghc-exceptions-dev (>= 0.6),
	libghc-unix-compat-dev,
	libghc-dlist-dev,
	libghc-uuid-dev,
	libghc-json-dev,
	libghc-aeson-dev,
	libghc-ifelse-dev,
	libghc-bloomfilter-dev,
	libghc-edit-distance-dev,
	libghc-hinotify-dev [linux-any],
	libghc-stm-dev (>= 2.3),
	libghc-dbus-dev (>= 0.10.7) [linux-any],
	libghc-fdo-notify-dev (>= 0.3) [linux-any],
	libghc-yesod-dev (>= 1.2.6.1)       [i386 amd64 arm64 armhf kfreebsd-amd64 kfreebsd-i386 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-yesod-core-dev (>= 1.2.19)   [i386 amd64 arm64 armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-yesod-form-dev (>= 1.3.15)   [i386 amd64 arm64 armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-yesod-static-dev (>= 1.2.4)  [i386 amd64 arm64 armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-yesod-default-dev (>= 1.2.0) [i386 amd64 arm64 armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-shakespeare-dev (>= 2.0.0)   [i386 amd64 arm64 armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-clientsession-dev            [i386 amd64 arm64 armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-warp-dev (>= 3.0.0.5)        [i386 amd64 arm64 armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-warp-tls-dev                 [i386 amd64 arm64 armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-wai-dev                      [i386 amd64 arm64 armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-wai-extra-dev                [i386 amd64 arm64 armhf kfreebsd-i386 kfreebsd-amd64 mips mips64el mipsel powerpc ppc64el s390x],
	libghc-dav-dev (>= 1.0),
	libghc-persistent-dev,
	libghc-persistent-template-dev,
	libghc-persistent-sqlite-dev,
	libghc-esqueleto-dev,
	libghc-securemem-dev,
	libghc-byteable-dev,
	libghc-dns-dev,
	libghc-case-insensitive-dev,
	libghc-http-types-dev,
	libghc-http-conduit-dev,
	libghc-blaze-builder-dev,
	libghc-crypto-api-dev,
	libghc-network-multicast-dev,
	libghc-network-info-dev [linux-any kfreebsd-any],
	libghc-safesemaphore-dev,
	libghc-network-protocol-xmpp-dev (>= 0.4.3-1+b1),
	libghc-gnutls-dev (>= 0.1.4),
	libghc-xml-types-dev,
	libghc-async-dev,
	libghc-monad-logger-dev,
	libghc-feed-dev (>= 0.3.9.2),
	libghc-regex-tdfa-dev,
	libghc-tasty-dev (>= 0.7),
	libghc-tasty-hunit-dev,
	libghc-tasty-quickcheck-dev,
	libghc-tasty-rerun-dev,
	libghc-optparse-applicative-dev (>= 0.11.0),
	libghc-cabal-dev,
	libghc-torrent-dev,
	libghc-concurrent-output-dev,
	libghc-disk-free-space-dev,
	libghc-mountpoints-dev,
	libghc-magic-dev,
	lsof [linux-any],
	ikiwiki,
	libimage-magick-perl,
	git (>= 1:1.8.1),
	rsync,
	wget,
	curl,
	openssh-client,
	git-remote-gcrypt (>= 0.20130908-6),
Maintainer: Richard Hartmann <richih@debian.org>
Standards-Version: 3.9.7
Vcs-Git: git://git.kitenet.net/git-annex
Homepage: http://git-annex.branchable.com/
XS-Testsuite: autopkgtest

Package: git-annex
Architecture: any
Section: utils
Depends: ${misc:Depends}, ${shlibs:Depends},
	git (>= 1:1.8.1),
	rsync,
	wget,
	curl,
	openssh-client (>= 1:5.6p1)
Recommends: 
	lsof,
	gnupg,
	bind9-host,
	quvi,
	git-remote-gcrypt (>= 0.20130908-6),
	nocache,
	aria2,
Suggests:
	graphviz,
	bup,
	tahoe-lafs,
	libnss-mdns,
Description: manage files with git, without checking their contents into git
 git-annex allows managing files with git, without checking the file
 contents into git. While that may seem paradoxical, it is useful when
 dealing with files larger than git can currently easily handle, whether due
 to limitations in memory, time, or disk space.
 .
 It can store large files in many places, from local hard drives, to a
 large number of cloud storage services, including S3, WebDAV,
 and rsync, with a dozen cloud storage providers usable via plugins.
 Files can be stored encrypted with gpg, so that the cloud storage
 provider cannot see your data. git-annex keeps track of where each file
 is stored, so it knows how many copies are available, and has many
 facilities to ensure your data is preserved.
 .
 git-annex can also be used to keep a folder in sync between computers,
 noticing when files are changed, and automatically committing them
 to git and transferring them to other computers. The git-annex webapp
 makes it easy to set up and use git-annex this way.

## git-annex 6.20160419

=== Makefile ===
mans=$(shell find doc -maxdepth 1 -name git-annex*.mdwn | sed -e 's/^doc/man/' -e 's/\.mdwn/\.1/')
all=git-annex mans docs

# set to "./Setup" if you lack a cabal program. Or can be set to "stack"
BUILDER?=cabal
GHC?=ghc

PREFIX?=/usr
SHAREDIR?=share

# Am I typing :make in vim? Do a fast build.
ifdef VIM
all=fast
endif

build: $(all)

Build/SysConfig.hs: configure.hs Build/TestConfig.hs Build/Configure.hs
	if [ "$(BUILDER)" = ./Setup ]; then ghc --make Setup; fi
	if [ "$(BUILDER)" = stack ]; then \
		$(BUILDER) build $(BUILDEROPTIONS); \
	else \
		$(BUILDER) configure --ghc-options="$(shell Build/collect-ghc-options.sh)"; \
	fi

git-annex: Build/SysConfig.hs
	$(BUILDER) build $(BUILDEROPTIONS)
	if [ "$(BUILDER)" = stack ]; then \
		ln -sf $$(find .stack-work/ -name git-annex -type f | grep build/git-annex/git-annex | tail -n 1) git-annex; \
	else \
		ln -sf dist/build/git-annex/git-annex git-annex; \
	fi

man/%.1: doc/%.mdwn
	./Build/mdwn2man $@ 1 $< > $@

# These are not built normally.
git-union-merge.1: doc/git-union-merge.mdwn
	./Build/mdwn2man git-union-merge 1 doc/git-union-merge.mdwn > git-union-merge.1
git-union-merge:
	$(GHC) --make -threaded $@

install-mans: mans
	install -d $(DESTDIR)$(PREFIX)/$(SHAREDIR)/man/man1
	install -m 0644 $(mans) $(DESTDIR)$(PREFIX)/$(SHAREDIR)/man/man1

install-docs: docs install-mans
	install -d $(DESTDIR)$(PREFIX)/$(SHAREDIR)/doc/git-annex
	if [ -d html ]; then \
		rsync -a --delete html/ $(DESTDIR)$(PREFIX)/$(SHAREDIR)/doc/git-annex/html/; \
	fi

install-bins: build
	install -d $(DESTDIR)$(PREFIX)/bin
	install git-annex $(DESTDIR)$(PREFIX)/bin
	ln -sf git-annex $(DESTDIR)$(PREFIX)/bin/git-annex-shell

install-misc: Build/InstallDesktopFile
	./Build/InstallDesktopFile $(PREFIX)/bin/git-annex || true
	install -d $(DESTDIR)$(PREFIX)/share/bash-completion/completions
	install -m 0644 bash-completion.bash $(DESTDIR)$(PREFIX)/share/bash-completion/completions/git-annex

install: install-bins install-docs install-misc

test: git-annex
	./git-annex test

retest: git-annex
	./git-annex test --rerun-update --rerun-filter failures

# hothasktags chokes on some template haskell etc, so ignore errors
tags:
	(for f in $$(find . | grep -v /.git/ | grep -v /tmp/ | grep -v /dist/ | grep -v /doc/ | egrep '\.hs$$'); do hothasktags -c --cpp -c -traditional -c --include=dist/build/autogen/cabal_macros.h $$f; done) 2>/dev/null | sort > tags

# If ikiwiki is available, build static html docs suitable for being
# shipped in the software package.
ifeq ($(shell which ikiwiki),)
IKIWIKI=echo "** ikiwiki not found, skipping building docs" >&2; true
else
IKIWIKI=ikiwiki
endif

mans: man $(mans)

man:
	mkdir -p man

docs: mans
	LC_ALL=C TZ=UTC $(IKIWIKI) doc html -v --wikiname git-annex \
		--plugin=goodstuff \
		--no-usedirs --disable-plugin=openid --plugin=sidebar \
		--underlaydir=/dev/null --set deterministic=1 \
		--disable-plugin=shortcut --disable-plugin=smiley \
		--plugin=comments --set comments_pagespec="*" \
		--exclude='news/.*' --exclude='design/assistant/blog/*' \
		--exclude='bugs/*' --exclude='todo/*' --exclude='forum/*' \
		--exclude='users/*' --exclude='devblog/*' --exclude='thanks'

clean:
	if [ "$(BUILDER)" != ./Setup ] && [ "$(BUILDER)" != cabal ]; then $(BUILDER) clean; fi
	rm -rf tmp dist git-annex $(mans) configure  *.tix .hpc \
		doc/.ikiwiki html dist tags Build/SysConfig.hs \
		Setup Build/InstallDesktopFile Build/EvilSplicer \
		Build/Standalone Build/OSXMkLibs Build/LinuxMkLibs \
		Build/DistributionUpdate Build/BuildVersion \
		git-union-merge .tasty-rerun-log
	find . -name \*.o -exec rm {} \;
	find . -name \*.hi -exec rm {} \;

Build/InstallDesktopFile: Build/InstallDesktopFile.hs
	$(GHC) --make $@ -Wall -fno-warn-tabs
Build/EvilSplicer: Build/EvilSplicer.hs
	$(GHC) --make $@ -Wall -fno-warn-tabs
Build/Standalone: Build/Standalone.hs Build/SysConfig.hs
	$(GHC) --make $@ -Wall -fno-warn-tabs
Build/OSXMkLibs: Build/OSXMkLibs.hs
	$(GHC) --make $@ -Wall -fno-warn-tabs
Build/LinuxMkLibs: Build/LinuxMkLibs.hs
	$(GHC) --make $@ -Wall -fno-warn-tabs

sdist: clean mans
	./Build/make-sdist.sh

# Upload to hackage.
hackage: sdist
	@cabal upload dist/*.tar.gz

LINUXSTANDALONE_DEST=tmp/git-annex.linux
linuxstandalone:
	$(MAKE) git-annex linuxstandalone-nobuild
linuxstandalone-nobuild: Build/Standalone Build/LinuxMkLibs
	rm -rf "$(LINUXSTANDALONE_DEST)"
	mkdir -p tmp
	cp -R standalone/linux/skel "$(LINUXSTANDALONE_DEST)"
	sed -i -e 's/^GIT_ANNEX_PACKAGE_INSTALL=/GIT_ANNEX_PACKAGE_INSTALL=$(GIT_ANNEX_PACKAGE_INSTALL)/' "$(LINUXSTANDALONE_DEST)/runshell"
	
	install -d "$(LINUXSTANDALONE_DEST)/bin"
	cp git-annex "$(LINUXSTANDALONE_DEST)/bin/"
	strip "$(LINUXSTANDALONE_DEST)/bin/git-annex"
	ln -sf git-annex "$(LINUXSTANDALONE_DEST)/bin/git-annex-shell"
	zcat standalone/licences.gz > $(LINUXSTANDALONE_DEST)/LICENSE
	cp doc/logo_16x16.png doc/logo.svg $(LINUXSTANDALONE_DEST)
	cp standalone/trustedkeys.gpg $(LINUXSTANDALONE_DEST)

	./Build/Standalone "$(LINUXSTANDALONE_DEST)"
	
	install -d "$(LINUXSTANDALONE_DEST)/git-core"
	(cd "$(shell git --exec-path)" && tar c .) | (cd "$(LINUXSTANDALONE_DEST)"/git-core && tar x)
	install -d "$(LINUXSTANDALONE_DEST)/templates"
	install -d "$(LINUXSTANDALONE_DEST)/magic"
	cp /usr/share/file/magic.mgc "$(LINUXSTANDALONE_DEST)/magic"
	
	./Build/LinuxMkLibs "$(LINUXSTANDALONE_DEST)"
	
	$(MAKE) install-mans DESTDIR="$(LINUXSTANDALONE_DEST)"

	cd tmp/git-annex.linux && find . -type f > git-annex.MANIFEST
	cd tmp/git-annex.linux && find . -type l >> git-annex.MANIFEST
	cd tmp && tar c git-annex.linux | gzip -9 --rsyncable > git-annex-standalone-$(shell dpkg --print-architecture).tar.gz

# Run this target to build git-annex-standalone*.deb
debianstandalone: dpkg-buildpackage-F
# Run this target to build git-annex-standalone*.dsc
debianstandalone-dsc: dpkg-buildpackage-S

prep-standalone:
	$(MAKE) undo-standalone
	QUILT_PATCHES=debian/patches QUILT_SERIES=series.standalone-build quilt push -a
	debian/create-standalone-changelog

undo-standalone:
	test -e .git
	git checkout debian/changelog
	quilt pop -a || true

commit-standalone:
	QUILT_PATCHES=debian/patches QUILT_SERIES=series.standalone-build  quilt refresh

dpkg-buildpackage%: prep-standalone
	umask 022; dpkg-buildpackage -rfakeroot $*
	$(MAKE) undo-standalone

OSXAPP_DEST=tmp/build-dmg/git-annex.app
OSXAPP_BASE=$(OSXAPP_DEST)/Contents/MacOS/bundle
osxapp: Build/Standalone Build/OSXMkLibs
	$(MAKE) git-annex

	rm -rf "$(OSXAPP_DEST)" "$(OSXAPP_BASE)"
	install -d tmp/build-dmg
	cp -R standalone/osx/git-annex.app "$(OSXAPP_DEST)"

	install -d "$(OSXAPP_BASE)"
	cp git-annex "$(OSXAPP_BASE)"
	strip "$(OSXAPP_BASE)/git-annex"
	ln -sf git-annex "$(OSXAPP_BASE)/git-annex-shell"
	gzcat standalone/licences.gz > $(OSXAPP_BASE)/LICENSE
	cp $(OSXAPP_BASE)/LICENSE tmp/build-dmg/LICENSE.txt
	cp standalone/trustedkeys.gpg $(OSXAPP_DEST)/Contents/MacOS

	./Build/Standalone $(OSXAPP_BASE)

	(cd "$(shell git --exec-path)" && tar c .) | (cd "$(OSXAPP_BASE)" && tar x)
	install -d "$(OSXAPP_BASE)/templates"
	install -d "$(OSXAPP_BASE)/magic"
	if [ -e "$(OSX_MAGIC_FILE)" ]; then \
		cp "$(OSX_MAGIC_FILE)" "$(OSXAPP_BASE)/magic/magic.mgc"; \
	else \
		echo "** OSX_MAGIC_FILE not set; not including it" >&2; \
	fi

	# OSX looks in man dir nearby the bin
	$(MAKE) install-mans DESTDIR="$(OSXAPP_BASE)/.." SHAREDIR="" PREFIX=""

	./Build/OSXMkLibs $(OSXAPP_BASE)
	cd $(OSXAPP_DEST) && find . -type f > Contents/MacOS/git-annex.MANIFEST
	cd $(OSXAPP_DEST) && find . -type l >> Contents/MacOS/git-annex.MANIFEST
	rm -f tmp/git-annex.dmg
	hdiutil create -format UDBZ -size 640m -srcfolder tmp/build-dmg \
		-volname git-annex -o tmp/git-annex.dmg

ANDROID_FLAGS?=
# Cross compile for Android.
# Uses https://github.com/neurocyte/ghc-android
android: Build/EvilSplicer
	echo "Running native build, to get TH splices.."
	if [ ! -e dist/setup/setup ]; then $(BUILDER) configure -O0 $(ANDROID_FLAGS) -fAndroidSplice;  fi
	mkdir -p tmp
	if ! $(BUILDER) build --ghc-options=-ddump-splices 2> tmp/dump-splices; then tail tmp/dump-splices >&2; exit 1; fi
	echo "Setting up Android build tree.."
	./Build/EvilSplicer tmp/splices tmp/dump-splices standalone/no-th/evilsplicer-headers.hs
	rsync -az --exclude tmp --exclude dist . tmp/androidtree
# Copy the files with expanded splices to the source tree, but
# only if the existing source file is not newer. (So, if a file
# used to have TH splices but they were removed, it will be newer,
# and not overwritten.)
	cp -uR tmp/splices/* tmp/androidtree || true
# Some additional dependencies needed by the expanded splices.
	sed -i 's/^  Build-Depends: */  Build-Depends: yesod-core, yesod-routes, shakespeare, blaze-markup, file-embed, wai-app-static, wai, unordered-containers, /' tmp/androidtree/git-annex.cabal
# Avoid warnings due to sometimes unused imports added for the splices.
	sed -i 's/GHC-Options: \(.*\)-Wall/GHC-Options: \1-Wall -fno-warn-unused-imports /i' tmp/androidtree/git-annex.cabal
	sed -i 's/Extensions: /Extensions: MagicHash /i' tmp/androidtree/git-annex.cabal
# Cabal cannot cross compile with custom build type, so workaround.
	sed -i 's/Build-type: Custom/Build-type: Simple/' tmp/androidtree/git-annex.cabal
# Build just once, but link repeatedly, for different versions of Android.
	mkdir -p tmp/androidtree/dist/build/git-annex/4.0 tmp/androidtree/dist/build/git-annex/4.3 tmp/androidtree/dist/build/git-annex/5.0
	if [ ! -e tmp/androidtree/dist/setup-config ]; then \
		cd tmp/androidtree && $$HOME/.ghc/$(shell cat standalone/android/abiversion)/arm-linux-androideabi/bin/cabal configure -fAndroid $(ANDROID_FLAGS); \
	fi
	cd tmp/androidtree && $$HOME/.ghc/$(shell cat standalone/android/abiversion)/arm-linux-androideabi/bin/cabal build \
		&& mv dist/build/git-annex/git-annex dist/build/git-annex/4.0/git-annex
	cd tmp/androidtree && $$HOME/.ghc/$(shell cat standalone/android/abiversion)/arm-linux-androideabi/bin/cabal build \
		--ghc-options=-optl-z --ghc-options=-optlnocopyreloc \
		&& mv dist/build/git-annex/git-annex dist/build/git-annex/4.3/git-annex
	cd tmp/androidtree && $$HOME/.ghc/$(shell cat standalone/android/abiversion)/arm-linux-androideabi/bin/cabal build \
		--ghc-options=-optl-z --ghc-options=-optlnocopyreloc --ghc-options=-optl-fPIE --ghc-options=-optl-pie --ghc-options=-optc-fPIE --ghc-options=-optc-pie \
		&& mv dist/build/git-annex/git-annex dist/build/git-annex/5.0/git-annex

androidapp:
	$(MAKE) android
	$(MAKE) -C standalone/android

# Bypass cabal, and only run the main ghc --make command for a
# faster development build.
fast: dist/cabalbuild
	@sh dist/cabalbuild
	@ln -sf dist/build/git-annex/git-annex git-annex
	@$(MAKE) tags >/dev/null 2>&1 &

dist/cabalbuild: dist/caballog
	grep 'ghc --make' dist/caballog | tail -n 1 > dist/cabalbuild
	
dist/caballog: git-annex.cabal
	$(BUILDER) configure -f"-Production" -O0 --enable-executable-dynamic
	$(BUILDER) build -v2 --ghc-options="-O0 -j" | tee dist/caballog

# Hardcoded command line to make hdevtools start up and work.
# You will need some memory. It's worth it.
# Note: Don't include WebDAV or Webapp. TH use bloats memory > 500 mb!
# TODO should be possible to derive this from caballog.
hdevtools:
	hdevtools --stop-server || true
	hdevtools check git-annex.hs -g -cpp -g -i -g -idist/build/git-annex/git-annex-tmp -g -i. -g -idist/build/autogen -g -Idist/build/autogen -g -Idist/build/git-annex/git-annex-tmp -g -IUtility -g -DWITH_TESTSUITE -g -DWITH_S3 -g -DWITH_ASSISTANT -g -DWITH_INOTIFY -g -DWITH_DBUS -g -DWITH_PAIRING -g -DWITH_XMPP -g -optP-include -g -optPdist/build/autogen/cabal_macros.h -g -odir -g dist/build/git-annex/git-annex-tmp -g -hidir -g dist/build/git-annex/git-annex-tmp -g -stubdir -g dist/build/git-annex/git-annex-tmp -g -threaded -g -Wall -g -XHaskell98 -g -XPackageImports

distributionupdate:
	git pull
	cabal configure
	ghc -Wall -fno-warn-tabs --make Build/DistributionUpdate -XPackageImports -optP-include -optPdist/build/autogen/cabal_macros.h
	./Build/DistributionUpdate

=== debian/changelog ===
git-annex (6.20160419-1) unstable; urgency=high

  * Package 6.20160419-1

 -- Richard Hartmann <richih@debian.org>  Sat, 30 Apr 2016 08:58:17 +0200

git-annex (6.20160419) unstable; urgency=medium

  * Fix bug that prevented resuming of uploads to encrypted special remotes
    that used chunking.
  * That bug could also expose the names of keys to such remotes when
    attempting to resume an upload, so it is a minor security issue.
  * Fix duplicate progress meter display when downloading from a git remote
    over http with -J.
  * reinject: When src file's content cannot be verified, leave it alone,
    instead of deleting it.
  * reinject: Added new mode which can reinject known files into the annex.
    For example: git-annex reinject --known /mnt/backup/*
  * calckey: New plumbing command, calculates the key that would be used
    to refer to a file.
  * Fix bug that prevented annex.sshcaching=false configuration from taking
    effect when on a crippled filesystem. Thanks, divergentdave.
  * git 2.9.0 is going to prevent git merge from merging in unrelated
    branches. Since the webapp's pairing etc features often combine
    together repositories with unrelated histories, work around
    this behavior change when the assistant merges, by passing
    --allow-unrelated-histories. Note though that this is not done
    for git annex sync's merges, so it will follow git's default or
    configured behavior.
  * When git-annex is used with a git version older than 2.2.0, disable
    support for adjusted branches, since GIT_COMMON_DIR is needed to update
    them and was first added in that version of git.
  * Avoid setting LOCPATH in linux standalone builds that are built with
    a ghc that has been fixed to not hang when it cannot find locale files.
  * Isolate test suite from global git config settings.

 -- Joey Hess <id@joeyh.name>  Thu, 28 Apr 2016 09:31:14 -0400

## git-annex 6.20160511

=== debian/changelog ===
git-annex (6.20160511-1) unstable; urgency=medium

  * Package 6.20160511-1

 -- Richard Hartmann <richih@debian.org>  Sat, 14 May 2016 15:50:11 +0200

git-annex (6.20160511) unstable; urgency=medium

  * Fix bug that sometimes prevented git-annex smudge --clean from consuming
    all its input, which resulted in git add bypassing git-annex.
  * Fix build with directory-1.2.6.2.
  * Improve behavior when a just added http remote is not available
    during uuid probe. Do not mark it as annex-ignore, so it will be tried
    again later.
  * Android: Icon refresh.
    Thanks, freewheelinfranks.
  * Added DIRHASH-LOWER to external special remote protocol.
  * git-annex.cabal: Add Setup-Depends.
  * stack.yaml: Enable explicit-setup-deps.
  * Windows: Fix several bugs in propigation of changes from the adjusted
    branch back to the master branch.
  * Windows: Fix an over-long temp directory name.
  * map: Hide dead repositories that are not connected to the graph.
  * map: Changed colors; red is used for untrusted repositories and grey
    for dead.
  * version: Display OS version and architecture too.
  * Propigate GIT_DIR and GIT_WORK_TREE environment to external special
    remotes.
  * Added annex.gnupg-decrypt-options and
    remote.<name>.annex-gnupg-decrypt-options, which are passed to gpg
    when it's decrypting data.
  * fsck: When a key is not previously known in the location log,
    record something so that reinject --known will work.
  * In the unusual configuration where annex.crippledfilesystem=true but
    core.symlinks=true, store object contents in mixed case hash
    directories so that symlinks will point to them.
  * Added new encryption=sharedpubkey mode for special remotes.
    This is useful for makking a special remote that anyone with a clone
    of the repo and your public keys can upload files to, but only you can
    decrypt the files stored in it.

 -- Joey Hess <id@joeyh.name>  Wed, 11 May 2016 12:41:42 -0400

=== debian/control ===
--- 
+++ 
@@ -18,6 +18,7 @@
 	libghc-resourcet-dev,
 	libghc-quickcheck2-dev,
 	libghc-monad-control-dev (>= 0.3),
+	libghc-transformers-dev,
 	libghc-exceptions-dev (>= 0.6),
 	libghc-unix-compat-dev,
 	libghc-dlist-dev,

## git-annex 6.20160613

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,3 @@
-mans=$(shell find doc -maxdepth 1 -name git-annex*.mdwn | sed -e 's/^doc/man/' -e 's/\.mdwn/\.1/')
 all=git-annex mans docs
 
 # set to "./Setup" if you lack a cabal program. Or can be set to "stack"
@@ -15,7 +14,7 @@
 
 build: $(all)
 
-Build/SysConfig.hs: configure.hs Build/TestConfig.hs Build/Configure.hs
+Build/SysConfig.hs: Build/TestConfig.hs Build/Configure.hs
 	if [ "$(BUILDER)" = ./Setup ]; then ghc --make Setup; fi
 	if [ "$(BUILDER)" = stack ]; then \
 		$(BUILDER) build $(BUILDEROPTIONS); \
@@ -31,9 +30,6 @@
 		ln -sf dist/build/git-annex/git-annex git-annex; \
 	fi
 
-man/%.1: doc/%.mdwn
-	./Build/mdwn2man $@ 1 $< > $@
-
 # These are not built normally.
 git-union-merge.1: doc/git-union-merge.mdwn
 	./Build/mdwn2man git-union-merge 1 doc/git-union-merge.mdwn > git-union-merge.1
@@ -42,7 +38,7 @@
 
 install-mans: mans
 	install -d $(DESTDIR)$(PREFIX)/$(SHAREDIR)/man/man1
-	install -m 0644 $(mans) $(DESTDIR)$(PREFIX)/$(SHAREDIR)/man/man1
+	install -m 0644 man/*.1 $(DESTDIR)$(PREFIX)/$(SHAREDIR)/man/man1
 
 install-docs: docs install-mans
 	install -d $(DESTDIR)$(PREFIX)/$(SHAREDIR)/doc/git-annex
@@ -80,10 +76,8 @@
 IKIWIKI=ikiwiki
 endif
 
-mans: man $(mans)
-
-man:
-	mkdir -p man
+mans: Build/MakeMans
+	./Build/MakeMans
 
 docs: mans
 	LC_ALL=C TZ=UTC $(IKIWIKI) doc html -v --wikiname git-annex \
@@ -102,7 +96,7 @@
 		doc/.ikiwiki html dist tags Build/SysConfig.hs \
 		Setup Build/InstallDesktopFile Build/EvilSplicer \
 		Build/Standalone Build/OSXMkLibs Build/LinuxMkLibs \
-		Build/DistributionUpdate Build/BuildVersion \
+		Build/DistributionUpdate Build/BuildVersion Build/Mans \
 		git-union-merge .tasty-rerun-log
 	find . -name \*.o -exec rm {} \;
 	find . -name \*.hi -exec rm {} \;
@@ -117,12 +111,12 @@
 	$(GHC) --make $@ -Wall -fno-warn-tabs
 Build/LinuxMkLibs: Build/LinuxMkLibs.hs
 	$(GHC) --make $@ -Wall -fno-warn-tabs
-
-sdist: clean mans
-	./Build/make-sdist.sh
+Build/MakeMans: Build/MakeMans.hs
+	$(GHC) --make $@ -Wall -fno-warn-tabs
 
 # Upload to hackage.
-hackage: sdist
+hackage:
+	@cabal sdist
 	@cabal upload dist/*.tar.gz
 
 LINUXSTANDALONE_DEST=tmp/git-annex.linux
@@ -170,7 +164,7 @@
 
 undo-standalone:
 	test -e .git
-	git checkout debian/changelog
+	git checkout debian/changelog CHANGELOG
 	quilt pop -a || true
 
 commit-standalone:
@@ -287,3 +281,4 @@
 	ghc -Wall -fno-warn-tabs --make Build/DistributionUpdate -XPackageImports -optP-include -optPdist/build/autogen/cabal_macros.h
 	./Build/DistributionUpdate
 
+.PHONY: git-annex git-union-merge tags

=== debian/changelog ===
git-annex (6.20160613-1) unstable; urgency=medium

  * Package 6.20160613-1

 -- Richard Hartmann <richih@debian.org>  Tue, 19 Jul 2016 18:48:50 +0200

git-annex (6.20160613) unstable; urgency=medium

  * Improve SHA*E extension extraction code.
  * Windows: Avoid terminating git-annex branch lines with \r\n when
    union merging and performing transitions.
  * Remove Makefile from cabal tarball; man page building is now handled by
    a small haskell program.
  * sync --content: Fix bug that caused transfers of files to be made 
    to a git remote that does not have a UUID. This particularly impacted
    clones from gcrypt repositories.
  * Pass -S to git commit-tree when commit.gpgsign is set and when
    making a non-automatic commit, in order to preserve current behavior
    when used with git 2.9, which has stopped doing this itself.
  * remotedaemon: Fixed support for notifications of changes to gcrypt
    remotes, which was never tested and didn't quite work before.
  * list: Do not include dead repositories.
  * move --to: Better behavior when system is completely out of disk space;
    drop content from disk before writing location log.
  * Avoid a crash if getpwuid does not work, when querying the user's full
    name.
  * Automatically enable v6 mode when initializing in a clone from a repo
    that has an adjusted branch checked out.
  * v6: Fix initialization of a bare clone of a repo that has an adjusted
    branch checked out.
  * v6: Fix bad automatic merge conflict resolution between an annexed file
    and a directory with the same name when in an adjusted branch.
  * v6: Fix bad merge in an adjusted branch that resulted in an empty tree.
  * v6: Fix bug in initialization of clone from a repo with an adjusted branch
    that had not been synced back to master. 
    (This bug caused broken tree objects to get built by a later git annex
    sync.)
  * v6: Make lock and unlock work on files whose content is not present.
  * v6: Fix update of associated files db when unlocking a file.
  * v6: Make git clean filter preserve the backend that was used for a file.

 -- Joey Hess <id@joeyh.name>  Mon, 13 Jun 2016 14:57:38 -0400

=== debian/control ===
--- 
+++ 
@@ -87,7 +87,7 @@
 	openssh-client,
 	git-remote-gcrypt (>= 0.20130908-6),
 Maintainer: Richard Hartmann <richih@debian.org>
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Vcs-Git: git://git.kitenet.net/git-annex
 Homepage: http://git-annex.branchable.com/
 XS-Testsuite: autopkgtest

## git-annex 6.20160719

=== Makefile ===
--- 
+++ 
@@ -28,6 +28,11 @@
 		ln -sf $$(find .stack-work/ -name git-annex -type f | grep build/git-annex/git-annex | tail -n 1) git-annex; \
 	else \
 		ln -sf dist/build/git-annex/git-annex git-annex; \
+	fi
+	# Work around https://github.com/haskell/cabal/issues/3524
+	# when not linked dynamically to haskell libs
+	@if ! ldd git-annex | grep -q libHS; then \
+		chrpath -d git-annex || echo "** unable to chrpath git-annex; it will be a little bit slower than necessary"; \
 	fi
 
 # These are not built normally.
@@ -96,7 +101,7 @@
 		doc/.ikiwiki html dist tags Build/SysConfig.hs \
 		Setup Build/InstallDesktopFile Build/EvilSplicer \
 		Build/Standalone Build/OSXMkLibs Build/LinuxMkLibs \
-		Build/DistributionUpdate Build/BuildVersion Build/Mans \
+		Build/DistributionUpdate Build/BuildVersion Build/MakeMans \
 		git-union-merge .tasty-rerun-log
 	find . -name \*.o -exec rm {} \;
 	find . -name \*.hi -exec rm {} \;
@@ -277,8 +282,3 @@
 
 distributionupdate:
 	git pull
-	cabal configure
-	ghc -Wall -fno-warn-tabs --make Build/DistributionUpdate -XPackageImports -optP-include -optPdist/build/autogen/cabal_macros.h
-	./Build/DistributionUpdate
-
-.PHONY: git-annex git-union-merge tags

=== debian/changelog ===
git-annex (6.20160719-1) unstable; urgency=medium

  * Package 6.20160719-1
  * Note that upstream typo-ed the version as June, I am releasing as July

 -- Richard Hartmann <richih@debian.org>  Wed, 20 Jul 2016 07:50:14 +0200

git-annex (6.20160619) unstable; urgency=medium

  * get, drop: Add --batch and --json options.
  * testremote: Fix crash when testing a freshly made external special remote.
  * Remove unnecessary rpaths in the git-annex binary, but only when
    it's built using make, not cabal. 
    This speeds up git-annex startup time by around 50%.
  * Speed up startup time by caching the refs that have been merged into
    the git-annex branch.
    This can speed up git-annex commands by as much as a second,
    depending on the number of remotes.
  * fsck: Fix a reversion in direct mode fsck of a file that is
    present when the location log thinks it is not. Reversion introduced
    in version 5.20151208.
  * uninit: Fix crash due to trying to write to deleted keys db.
    Reversion introduced by v6 mode support, affects v5 too.
  * Fix a similar crash when the webapp is used to delete a repository.
  * Support checking presence of content at a http url that redirects to
    a ftp url.
  * log: Added --all option.
  * New url for git-remote-gcrypt, now maintained by spwhitton.
  * webapp: Don't allow deleting a remote that has syncing disabled,
    as such a deletion will never finish.
    Thanks, Farhan Kathawala.
  * webapp: Escape unusual characters in ssh hostnames when generating
    mangled hostnames. This allows IPv6 addresses to be used on filesystems
    not supporting : in filenames.
  * Avoid any access to keys database in v5 mode repositories, which 
    are not supposed to use that database.
  * Remove the EKG build flag, since Gentoo for some reason decided to
    enable this flag, depsite it not being intended for production use and
    so disabled by default.

 -- Joey Hess <id@joeyh.name>  Tue, 19 Jul 2016 14:17:54 -0400

=== debian/control ===
--- 
+++ 
@@ -86,6 +86,7 @@
 	curl,
 	openssh-client,
 	git-remote-gcrypt (>= 0.20130908-6),
+	chrpath,
 Maintainer: Richard Hartmann <richih@debian.org>
 Standards-Version: 3.9.8
 Vcs-Git: git://git.kitenet.net/git-annex

## git-annex 6.20160923

=== debian/changelog ===
git-annex (6.20160923-1) unstable; urgency=medium

  * Package 6.20160923-1

 -- Richard Hartmann <richih@debian.org>  Fri, 30 Sep 2016 20:31:25 +0200

git-annex (6.20160923) unstable; urgency=medium

  * Rate limit console progress display updates to 10 per second.
    Was updating as frequently as changes were reported, up to hundreds of
    times per second, which used unncessary bandwidth when running git-annex
    over ssh etc.
  * Make --json and --quiet work when used with -J.
    Previously, -J override the other options.
  * addurl, get: Added --json-progress option, which adds progress
    objects to the json output.
  * Remove key:null from git-annex add --json output.
  * copy, move, mirror: Support --json and --json-progress.
  * Improve gpg secret key list parser to deal with changes in gpg 2.1.15.
    Fixes key name display in webapp.
  * info: Support being passed a treeish, and show info about the annexed
    files in it similar to how a directory is handled.
  * sync: Previously, when run in a branch with a slash in its name,
    such as "foo/bar", the sync branch was "synced/bar". That conflicted
    with the sync branch used for branch "bar", so has been changed to
    "synced/foo/bar".
  * Note that if you're using an old version of git-annex to sync with
    a branch with a slash in its name, it won't see some changes synced by
    this version, and this version won't see some changes synced by the older
    version. This is not a problem if there's a central bare repository,
    but may impact other configurations until git-annex is upgraded to this
    version.
  * adjust: Previously, when adjusting a branch with a slash in its name,
    such as "foo/bar", the adjusted branch was "adjusted/bar(unlocked)".
    That conflicted with the adjusted branch used for branch "bar",
    so has been changed to "adjusted/foo/bar(unlocked)"
  * Also, running sync in an adjusted branch did not correctly sync
    changes back to the parent branch when it had a slash in its name.
    This bug has been fixed.
  * addurl, importfeed: Improve behavior when file being added is gitignored.

 -- Joey Hess <id@joeyh.name>  Fri, 23 Sep 2016 09:43:26 -0400

git-annex (6.20160907) unstable; urgency=medium

  * Windows: Handle shebang in external special remote program.
  * Fix formatting of git-annex-smudge man page, and improve mdwn2man.
    Thanks, Jim Paris.
  * examimekey: Allow being run in a git repo that is not initialized by
    git-annex yet.
  * Android: Fix disabling use of cp --reflink=auto, curl, sha224, and sha384.
  * Make --json and --quiet suppress automatic init messages, and any
    other messages that might be output before a command starts.
    Fixes a reversion introduced in version 5.20150727.
  * Assistant, repair: Filter out git fsck lines about duplicate file
    entries in tree objects.
  * get -J, sync --content -J: Download different files from different
    remotes when the remotes have the same costs.

 -- Joey Hess <id@joeyh.name>  Wed, 07 Sep 2016 11:12:11 -0400

git-annex (6.20160808-1) unstable; urgency=medium

  * Package 6.2016008-1

 -- Richard Hartmann <richih@debian.org>  Sat, 27 Aug 2016 01:23:16 +0200

git-annex (6.20160808) unstable; urgency=medium

  * metadata --json output format has changed, adding a inner json object
    named "fields" which contains only the fields and their values.
    This should be easier to parse than the old format, which mixed up
    metadata fields with other keys in the json object.
    Any consumers of the old format will need to be updated.
  * Added metadata --batch option, which allows getting, setting, deleting,
    and modifying metadata for multiple files/keys.
  * Added --branch option to copy, drop, fsck, get, metadata, mirror, move,
    and whereis commands. This option makes git-annex operate on files that
    are included in a specified branch (or other treeish).
  * git-annex.cabal: Temporarily limit to http-conduit <2.2.0
    since aws 0.14.0 is not compatible with the newer version.
  * git-annex.cabal: Temporarily limit to persistent <2.5
    since esqueleto 2.4.3 is not compatible with the newer version.
  * Removed dependency on json library; all JSON is now handled by aeson.
  * When built with uuid-1.3.12, generate more random UUIDs than before.
    (However, this did not impact git-annex much, so a hard depedency has
    not been added on uuid-1.3.12.)
  * info: When run on a file now includes an indication of whether
    the content is present locally.
  * get, move, copy, mirror: Added --failed switch which retries
    failed copies/moves.
  * Re-enable accumulating transfer failure log files for command-line
    actions (disabled in 5.20150522), and remove the log files after
    successful transfers.

 -- Joey Hess <id@joeyh.name>  Mon, 08 Aug 2016 11:42:17 -0400

=== debian/control ===
--- 
+++ 
@@ -23,8 +23,8 @@
 	libghc-unix-compat-dev,
 	libghc-dlist-dev,
 	libghc-uuid-dev,
-	libghc-json-dev,
 	libghc-aeson-dev,
+	libghc-unordered-containers-dev,
 	libghc-ifelse-dev,
 	libghc-bloomfilter-dev,
 	libghc-edit-distance-dev,

## git-annex 6.20161012

=== debian/changelog ===
git-annex (6.20161012-1) unstable; urgency=medium

  * Package 6.20161012-1

 -- Richard Hartmann <richih@debian.org>  Tue, 25 Oct 2016 21:28:12 +0200

git-annex (6.20161012) unstable; urgency=medium

  * Optimisations to time it takes git-annex to walk working tree and find
    files to work on. Sped up by around 18%.
  * Optimisations to git-annex branch query and setting, avoiding repeated
    copies of the environment. Speeds up commands like 
    "git-annex find --in remote" by over 50%.
  * Optimised git-annex branch log file timestamp parsing.
  * Add "total-size" field to --json-progress output.
  * Make --json-progress output be shown even when the size of a object
    is not known.
  * Multiple external special remote processes for the same remote will be
    started as needed when using -J. This should not beak any existing
    external special remotes, because running multiple git-annex commands
    at the same time could already start multiple processes for the same
    external special remotes.
  * Linux standalone: Include locale files in the bundle, and generate
    locale definition files for the locales in use when starting runshell.
    (Currently only done for utf-8 locales.)
  * Avoid using a lot of memory when large objects are present in the git
    repository and have to be checked to see if they are a pointed to an
    annexed file. Cases where such memory use could occur included, but
    were not limited to:
    - git commit -a of a large unlocked file (in v5 mode)
    - git-annex adjust when a large file was checked into git directly
  * When auto-upgrading a v3 remote, avoid upgrading to version 6,
    instead keep it at version 5.
  * Support using v3 repositories without upgrading them to v5.
  * sync: Fix bug in adjusted branch merging that could cause recently
    added files to be lost when updating the adjusted branch.

 -- Joey Hess <id@joeyh.name>  Wed, 12 Oct 2016 09:37:41 -0400
